searchNodes=[{"ref":"Etso.html","title":"Etso","type":"module","doc":"Top-level module for Etso."},{"ref":"Etso.html#t:repo/0","title":"Etso.repo/0","type":"type","doc":""},{"ref":"Etso.html#t:schema/0","title":"Etso.schema/0","type":"type","doc":""},{"ref":"Etso.html#t:table/0","title":"Etso.table/0","type":"type","doc":""},{"ref":"Etso.Adapter.html","title":"Etso.Adapter","type":"module","doc":"Used as an Adapter in Repo modules, which transparently spins up one ETS table for each Schema used with the Repo, namespaced to the Repo to allow concurrent running of multiple Repositories. The Etso Adapter implements the Ecto.Adapter.Schema and Ecto.Adapter.Queryable behaviours. To use the Etso Adapter in your application, define a Repo like this: defmodule MyApp.Repo do @otp_app Mix.Project.config()[:app] use Ecto.Repo, otp_app: @otp_app, adapter: Etso.Adapter end"},{"ref":"Etso.Adapter.Supervisor.html","title":"Etso.Adapter.Supervisor","type":"module","doc":"Repo-level Supervisor which supports the ETS Adapter. Within the Supervision Tree, a Dynamic Supervisor is used to hold the Table Servers, and a Registry is used to keep track of both the Table Servers, and their ETS Tables."},{"ref":"Etso.Adapter.Supervisor.html#child_spec/1","title":"Etso.Adapter.Supervisor.child_spec/1","type":"function","doc":"Returns a specification to start this module under a supervisor. See Supervisor."},{"ref":"Etso.Adapter.Supervisor.html#start_link/1","title":"Etso.Adapter.Supervisor.start_link/1","type":"function","doc":"Starts the Supervisor for the given repo."},{"ref":"Etso.Adapter.TableRegistry.html","title":"Etso.Adapter.TableRegistry","type":"module","doc":"Provides convenience function to spin up a Registry, which is used to hold the Table Servers (registered by GenServer when starting up), alongside their ETS tables (registered when the Table Server starts)."},{"ref":"Etso.Adapter.TableRegistry.html#child_spec/1","title":"Etso.Adapter.TableRegistry.child_spec/1","type":"function","doc":"Returns Child Specification for the Table Registry that will be associated with the repo."},{"ref":"Etso.Adapter.TableRegistry.html#get_table/2","title":"Etso.Adapter.TableRegistry.get_table/2","type":"function","doc":"Returns the ETS table associated with the given repo which is used to hold data for schema."},{"ref":"Etso.Adapter.TableRegistry.html#register_table/3","title":"Etso.Adapter.TableRegistry.register_table/3","type":"function","doc":"Registers the ETS table associated with the given repo which is used to hold data for schema."},{"ref":"Etso.Adapter.TableServer.html","title":"Etso.Adapter.TableServer","type":"module","doc":"The Table Server is a simple GenServer tasked with starting and holding an ETS table, which is namespaced in the Table Registry by the Repo and the Schema. Once the Table Server starts, it will attempt to create the ETS table, and also register the ETS table with the Table Registry."},{"ref":"Etso.Adapter.TableServer.html#child_spec/1","title":"Etso.Adapter.TableServer.child_spec/1","type":"function","doc":"Returns a specification to start this module under a supervisor. See Supervisor."},{"ref":"Etso.Adapter.TableServer.html#start_link/1","title":"Etso.Adapter.TableServer.start_link/1","type":"function","doc":"Starts the Table Server for the given repo and schema, with registration under name."},{"ref":"Etso.Adapter.TableSupervisor.html","title":"Etso.Adapter.TableSupervisor","type":"module","doc":"Provides convenience function to spin up a Dynamic Supervisor, which is used to hold the Table Servers."},{"ref":"Etso.Adapter.TableSupervisor.html#child_spec/1","title":"Etso.Adapter.TableSupervisor.child_spec/1","type":"function","doc":"Returns Child Specification for the Table Supervisor that will be associated with the repo."},{"ref":"Etso.Adapter.TableSupervisor.html#start_child/2","title":"Etso.Adapter.TableSupervisor.start_child/2","type":"function","doc":"Starts the Child under the Table Supervisor associated with the repo."},{"ref":"Etso.ETS.MatchSpecification.html","title":"Etso.ETS.MatchSpecification","type":"module","doc":"The ETS Match Specifications module contains various functions which convert Ecto queries to ETS Match Specifications in order to execute the given queries."},{"ref":"Etso.ETS.MatchSpecification.html#build/2","title":"Etso.ETS.MatchSpecification.build/2","type":"function","doc":""},{"ref":"Etso.ETS.TableStructure.html","title":"Etso.ETS.TableStructure","type":"module","doc":"The ETS Table Structure module contains various convenience functions to aid the transformation between Ecto Schemas (maps) and ETS entries (tuples). The primary key is moved to the head, in accordance with ETS conventions. Composite primary keys can not be accepted, however."},{"ref":"Etso.ETS.TableStructure.html#entries_to_tuples/2","title":"Etso.ETS.TableStructure.entries_to_tuples/2","type":"function","doc":""},{"ref":"Etso.ETS.TableStructure.html#field_names/1","title":"Etso.ETS.TableStructure.field_names/1","type":"function","doc":""},{"ref":"Etso.ETS.TableStructure.html#fields_to_tuple/2","title":"Etso.ETS.TableStructure.fields_to_tuple/2","type":"function","doc":""},{"ref":"readme.html","title":"Etso","type":"extras","doc":"Etso Etso is an ETS adapter, allowing you to use Ecto schemas with ETS tables. Within this library, a bare-bones Ecto Adapter is provided. The Adapter transparently spins up ETS tables for each Ecto Repo and Schema combination. The tables are publicly accessible to enable concurrency, and tracked by reference to ensure encapsulation. Each ETS table is spun up by a dedicated Table Server under a shared Dynamic Supervisor. For a detailed look as to what is available, check out Northwind Repo Test."},{"ref":"readme.html#highlights-benefits","title":"Etso - Highlights &amp; Benefits","type":"extras","doc":"Key highlights of this library are: It transparently handles translations between Ecto.Schema structs and ETS tuples. It knows how to form ETS Match Specifications for simple queries. Key points to consider when adopting this library are: It is suitable for rapid retrieval of simply formatted data, for example presets that do not change frequently. It is not suitable for use as a full-fledged data layer unless your requirements are simple."},{"ref":"readme.html#feature-coverage","title":"Etso - Feature Coverage","type":"extras","doc":"The following features are working: Basic query scenarios (C / R / U / D) Insert all (Ecto.Repo.insert_all/3, etc.) Insert one (Ecto.Repo.insert/2, etc.) Get all (Ecto.Repo.all/2, etc.) Get by ID (Ecto.Repo.get/3, etc.) Get where (Ecto.Query.where/3, etc.) Delete by ID (Ecto.Repo.delete/2, etc.) Selects Assocs Preloads The Northwind Repo Test should give you a good idea of what’s included. Missing Features The following features, for example, are missing: Composite primary keys Dynamic Repos (Ecto.Repo.put_dynamic_repo/1) Aggregates (dynamic / static) Joins Windows Transactions Migrations Locking"},{"ref":"readme.html#installation","title":"Etso - Installation","type":"extras","doc":"Using Etso is a two-step process. First, include it in your application’s dependencies: defp deps do [ {:etso, &quot;~&gt; 0.1.4&quot;} ] end Afterwards, create a new Ecto.Repo, which uses Etso.Adapter: defmodule MyApp.Repo do @otp_app Mix.Project.config()[:app] use Ecto.Repo, otp_app: @otp_app, adapter: Etso.Adapter end Once this is done, you can use any Schema against the Repo normally, as you would with any other Repo. Check out the Northwind modules for an example."},{"ref":"readme.html#utilisation","title":"Etso - Utilisation","type":"extras","doc":"Originally, Etso was created to answer the question of whether ETS and Ecto can be married together. It has since found some uses in production applications, serving as a Data Repository for pre-defined nested content. This proved invaluable for rapid iteration. If you have other Use Cases for this library, please add it here with a Pull Request. The Erlef Website is using Etso to cache and query news and event posts that are parsed and imported into the Repo on application startup."},{"ref":"readme.html#further-note","title":"Etso - Further Note","type":"extras","doc":"This repository is extracted from a prior project ETS Playground, which was created to support a session at ElixirConf EU 2019, Leveraging ETS Effectively. Specifically, this library was created to illustrate the point that ETS can serve as a scalable storage layer for data which changes infrequently. Check out the Northwind Importer for an example."},{"ref":"readme.html#acknowledgements","title":"Etso - Acknowledgements","type":"extras","doc":"This project contains a copy of data obtained from the Northwind database, which is owned by Microsoft. It is included for demonstration and testing purposes only, and is excluded from the distribution. The Author thanks Microsoft Corporation for the inspiration. The Author also wishes to thank the following individuals: Wojtek Mach, for the inspiration regarding creation of an Ecto adapter for ETS. Steven Holdsworth, for initial concept proofing and refinement. Igor Kopestenski, for initial reviews. David Schainker, for initial reviews, and for finding uses for this library. Masanori Iwasaki, for support of for…in queries. Kohei Noda, for fixing nested {:orelse, …} queries."}]